// Copyright 2002-2003 University of Guelph, All Rights Reserved
import java.io.*;
import java.util.*;

class Arc extends Main {
  static {
	EXE_NAME = "Arc";
	Debug.DEBUG_LEVEL = Debug.DEBUG_OFF;
  }

  public static void main(String[] Args) throws IOException, Exception {
	Main.main(Args);
	makeArcConsistent();

    if (!quiet) {
		problem.printSolution();
		System.out.println(String.valueOf(problem.numChecks) +
						   " checks.");
	} else {
	  System.out.print(String.valueOf(problem.numChecks) + " ");	  
	  solnOut.print(problem.getSolutionString());
	}	
	
	if (useSolnFile) {	  
	  solnOut.close();
	}
  }

  public static void makeArcConsistent() {
	problem.arc3();	
	
	for (int i = 1; i <= problem.getMaxVars(); i++) {
	  if (problem.domain[i] != null) {
		Iterator di = problem.domain[i].iterator();

		if (di.hasNext()) {
		  problem.solution[i] = ((Integer)(di.next())).intValue();
		  if (di.hasNext()) {
			System.out.println("Arc consistency is not sufficient to solve this problem.");
		  }
		} else {
		  System.out.println("No solution");
		  break;
		} 
	  } else {
		System.out.println("Domain doesn't exist.  What gives?");
	  }
	}
  }  
}

